<template>
    <div
        v-if="pageReady"
        class="w-full bg-white"
    >
        <div
            class="bg-neutral flex justify-between items-center py-4"
        >
            <div class="w-12 cursor-pointer pl-4 text-white">
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="2x"
                    @click="$router.go(-1)"
                />
            </div>
            <div
                class="flex-1 flex justify-center"
            >
                <a
                    href="javascript:"
                    class=""
                    @click="$router.push({name: 'user.home'})"
                >
                    <img
                        :src="'/img/logo-only.png'"
                        class="h-8"
                    />
                </a>
            </div>
            <div class="w-12" />
        </div>

        <div
            class="my-8 px-4"
        >
            <div
                class="mb-4 font-black text-2xl"
            >
                {{ article.subject }}
            </div>
            <div class="font-bold capitalize flex justify-between space-x-2 items-center">
                <div class="flex-1">
                    {{ article.category }} · {{ moment(article.created_at).format('DD MMM YYYY') }}
                </div>
                <a
                    href="javascript:"
                    class="rounded-full w-8 h-8 bg-sky-200 text-blue-700 text-center flex justify-center items-center share-btn"
                    @click="shareArticle(article)"
                >
                    <font-awesome-icon
                        icon="fa-solid fa-share-nodes"
                        size="1x"
                    />
                </a>
            </div>
            <div class="my-4">
                <img
                    :src="article.cover"
                    class="w-full h-auto object-cover mx-auto"
                />
            </div>
            <div
                class="content-container pb-4"
                v-html="$helper.editorJsParser(article.content)"
            />
        </div>
    </div>
</template>

<script setup>
import {ref, onMounted} from "vue";
import axios from "axios";
import {useRoute, useRouter} from "vue-router";
import moment from "moment";

const $route = useRoute();
const $router = useRouter();
const article = ref(null);
const pageReady = ref(false);

onMounted(async () => {
    try {
        const data = await axios.post('/article/fetch', {
            id: $route.params.id,
        });

        if (data.article) {
            article.value = data.article;
        } else {
            await $router.push({name: 'user.home'});
        }
    } catch (e) {
        console.log(e);
    } finally {
        pageReady.value = true;
    }
});

const shareArticle = async (article) => {
    // Create new element
    let el = document.createElement('textarea');
    let r = $router.resolve({name: 'user.home.article', params: {
            id: article.id
        }});
    // Set value (string to be copied)
    el.value = window.location.protocol + '//' + window.location.host + r.fullPath;
    // Set non-editable to avoid focus and move outside of view
    el.setAttribute('readonly', '');
    el.setAttribute('style', {position: 'absolute', left: '-9999px'})
    document.body.appendChild(el);
    // Select text inside element
    el.select();
    // Copy text to clipboard
    document.execCommand('copy');
    // Remove temporary element
    document.body.removeChild(el);

    if (navigator && navigator.share) {
        await navigator.share({
            title: article.subject,
            url: r.fullPath,
        });
    }
};
</script>
